/*
 *
 *
 */
#ifndef __TDM_CHANNEL_H__
#define __TDM_CHANNEL_H__

/**
 * @brief I/O Modules per-channel ops
 * @todo  rework for event based I/O scheme
 */
struct tdm_channel_ops {
	tdm_status_t (* channel_open)(struct tdm_channel *chan, const int flags);
	tdm_status_t (* channel_read)(struct tdm_channel *chan, char *buffer, size_t *size);		/* read data incoming on channel */
	tdm_status_t (* channel_write)(struct tdm_channel *chan, const char *buffer, size_t *size);	/* write data outgoing on channel */
	tdm_status_t (* channel_close)(struct tdm_channel *chan);
};

struct tdm_channel {
	struct tdm_object obj;

	struct tdm_port        *port;
	struct tdm_span        *span;
	struct tdm_channel_ops *ops;

	struct dlist_head      span_channel_list;	/* => span->channels */
	struct dlist_head      port_channel_list;	/* => port->channels */
};

struct tdm_channel *tdm_channel_new(const char *name);
void tdm_channel_set_owner(struct tdm_channel *chan, struct tdm_module *owner);
int tdm_channel_has_span(struct tdm_channel *chan);

struct tdm_channel *tdm_object_to_channel(struct tdm_object *obj);
struct tdm_module *tdm_channel_get_module(struct tdm_channel *chan);
struct tdm_span *tdm_channel_get_span(struct tdm_channel *chan);

#endif /* __TDM_CHANNEL_H__ */
