/*
 *
 *
 */
#ifndef __TDM_EVENT_H__
#define __TDM_EVENT_H__

typedef enum {
	TDM_EVENT_NONE = 0,
	TDM_EVENT_SPAN,
	TDM_EVENT_CHANNEL,
	TDM_EVENT_PORT,
	TDM_EVENT_DEVICE,
	TDM_EVENT_MAX			/*!< always last! */
} tdm_event_class_t;

struct tdm_event {
	int ev_class, ev_type;		/* e.g. TDM_EVENT_SPAN : TDM_SPAN_EVENT_READY */

	union {
		struct tdm_span    *span;
		struct tdm_channel *channel;
		struct tdm_device  *device;
		struct tdm_port    *port;
	} ev_obj;

	union {
		void *custom;
	} ev_data;

	void (* ev_destroy)(struct tdm_event *event);
};

struct tdm_event *tdm_event_new(const int ev_class);

int tdm_event_class(const struct tdm_event *event);
void tdm_event_set_class(struct tdm_event *event, const int ev_class);

tdm_status_t tdm_event_queue(struct tdm_event *event);

#endif /* __TDM_EVENT_H__ */
