#ifndef _COMMON_H_
#define _COMMON_H_

#include <stdlib.h>

#ifndef MIN
#define MIN(x,y)	((x < y) ? x : y)
#endif

#ifndef MAX
#define MAX(x,y)	((x > y) ? x : y)
#endif

#ifndef ARRAY_SIZE
#define ARRAY_SIZE(x)	(sizeof(x) / sizeof(x[0]))
#endif

/**
 * Offset of an element within the struct
 */
#ifndef offset_of
#define offset_of(type, member)			\
	(unsigned long)&(((type *)0)->member)
#endif

/**
 * Pointer to the struct containing the given element
 */
#ifndef container_of
#define container_of(ptr, type, member)				\
	(type *)((unsigned long)ptr - offset_of(type, member))
#endif

#ifdef __GNUC__
#define unlikely(expr)	__builtin_expect(!!(expr), 0)
#define likely(expr)	__builtin_expect(!!(expr), 1)
#else
#define unlikely(expr)	(expr)
#define likely(expr)	(expr)
#endif

#endif
