/*
 * tdm device tree
 *
 */
#include <stdio.h>
#include <string.h>

#include "tdm_private.h"
#include "tdm_common.h"
#include "tdm_log.h"
#include "tdm_module.h"


static struct {
	int nr_devices;
	/* device list */
} devtree_root;


/* TODO: print a nice tree-like structure */
int tdm_devtree_print(void)
{
	tdm_info("Device tree contains %d devices\n", devtree_root.nr_devices);
	return TDM_STATUS_SUCCESS;
}

#ifdef __TODO__
int tdm_devices_count_by_owner(const struct tdm_module_handle *owner)
{
	struct tdm_device *device = NULL;
	int count = 0;

	tdm_device_for_each(&devtree_root->devices, device) {
		if (device->owner == owner)
			count++;
	}
	return count;
}
#endif

int tdm_devices_count(void)
{
	return devtree_root.nr_devices;
}


/*
 * Device functions (API likely to change)
 */
#define TDM_DEVICE_NAME_MAX	20

struct tdm_device {
	char name[TDM_DEVICE_NAME_MAX];

	struct tdm_module_handle *owner;

	int nr_ports;
	/* port list */
};

struct tdm_port {
	int nr_channels;
	/* channel list */
};


int tdm_device_register(const struct tdm_device *device)
{
	return TDM_STATUS_SUCCESS;
}

int tdm_device_unregister(const struct tdm_device *device)
{
	return TDM_STATUS_SUCCESS;
}

int tdm_device_set_name(struct tdm_device *device, const char *name)
{
	int size;

	if (!device || !name || !name[0])
		return TDM_STATUS_INVALID;

	size = MIN(strlen(name), TDM_DEVICE_NAME_MAX - 1);
	memcpy(device->name, name, size);
	device->name[size] = '\0';

	return TDM_STATUS_SUCCESS;
}

const char *tdm_device_get_name(const struct tdm_device *device)
{
	return device->name;
}


int tdm_device_add_port(struct tdm_device *device, struct tdm_port *port)
{
	return TDM_STATUS_SUCCESS;
}

int tdm_device_remove_port(struct tdm_device *device, struct tdm_port *port)
{
	return TDM_STATUS_SUCCESS;
}



/*
 * Device tree init/cleanup functions
 */

int tdm_devtree_init(void)
{
	memset(&devtree_root, 0, sizeof(devtree_root));
	return TDM_STATUS_SUCCESS;
}

int tdm_devtree_fini(void)
{
	return TDM_STATUS_SUCCESS;
}
